/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 *  ianjuta-variable-debugger.h -- Autogenerated from libanjuta.idl
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _IANJUTA_VARIABLE_DEBUGGER_H_
#define _IANJUTA_VARIABLE_DEBUGGER_H_

#include <glib-object.h>
#include <libanjuta/interfaces/ianjuta-debug-manager.h>
#include <libanjuta/interfaces/ianjuta-debugger.h>
#include <sys/types.h>

G_BEGIN_DECLS

#define IANJUTA_TYPE_VARIABLE_DEBUGGER (ianjuta_variable_debugger_get_type ())
#define IANJUTA_VARIABLE_DEBUGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IANJUTA_TYPE_VARIABLE_DEBUGGER, IAnjutaVariableDebugger))
#define IANJUTA_IS_VARIABLE_DEBUGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IANJUTA_TYPE_VARIABLE_DEBUGGER))
#define IANJUTA_VARIABLE_DEBUGGER_GET_IFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), IANJUTA_TYPE_VARIABLE_DEBUGGER, IAnjutaVariableDebuggerIface))

#define IANJUTA_VARIABLE_DEBUGGER_ERROR ianjuta_variable_debugger_error_quark()

typedef struct _IAnjutaVariableDebugger IAnjutaVariableDebugger;
typedef struct _IAnjutaVariableDebuggerIface IAnjutaVariableDebuggerIface;

struct _IAnjutaVariableDebuggerIface {
	GTypeInterface g_iface;
	

	gboolean (*assign) (IAnjutaVariableDebugger *obj, const gchar *name,  const gchar *value, GError **err);
	gboolean (*create) (IAnjutaVariableDebugger *obj, const gchar *name,  IAnjutaDebuggerCallback callback,  gpointer user_data, GError **err);
	gboolean (*delete_var) (IAnjutaVariableDebugger *obj, const gchar *name, GError **err);
	gboolean (*evaluate) (IAnjutaVariableDebugger *obj, const gchar *name,  IAnjutaDebuggerCallback callback,  gpointer user_data, GError **err);
	gboolean (*list_children) (IAnjutaVariableDebugger *obj, const gchar *name,  IAnjutaDebuggerCallback callback,  gpointer user_data, GError **err);
	gboolean (*update) (IAnjutaVariableDebugger *obj, IAnjutaDebuggerCallback callback,  gpointer user_data, GError **err);

};

GQuark ianjuta_variable_debugger_error_quark     (void);
GType  ianjuta_variable_debugger_get_type        (void);

gboolean ianjuta_variable_debugger_assign (IAnjutaVariableDebugger *obj, const gchar *name,  const gchar *value, GError **err);

gboolean ianjuta_variable_debugger_create (IAnjutaVariableDebugger *obj, const gchar *name,  IAnjutaDebuggerCallback callback,  gpointer user_data, GError **err);

gboolean ianjuta_variable_debugger_delete_var (IAnjutaVariableDebugger *obj, const gchar *name, GError **err);

gboolean ianjuta_variable_debugger_evaluate (IAnjutaVariableDebugger *obj, const gchar *name,  IAnjutaDebuggerCallback callback,  gpointer user_data, GError **err);

gboolean ianjuta_variable_debugger_list_children (IAnjutaVariableDebugger *obj, const gchar *name,  IAnjutaDebuggerCallback callback,  gpointer user_data, GError **err);

gboolean ianjuta_variable_debugger_update (IAnjutaVariableDebugger *obj, IAnjutaDebuggerCallback callback,  gpointer user_data, GError **err);


G_END_DECLS

#endif
